const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const referral_conversions = sequelize.define(
    'referral_conversions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

converted_at: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"qualified",


"disqualified"

        ],

      },

commission_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  referral_conversions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.referral_conversions.belongsTo(db.referral_links, {
      as: 'referral_link',
      foreignKey: {
        name: 'referral_linkId',
      },
      constraints: false,
    });

    db.referral_conversions.belongsTo(db.users, {
      as: 'referred_user',
      foreignKey: {
        name: 'referred_userId',
      },
      constraints: false,
    });

    db.referral_conversions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.referral_conversions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.referral_conversions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return referral_conversions;
};


